#include <bits/stdc++.h>
using namespace std;

long long a[300000], p[300000], pr[300000];

int main() {
    ios::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    long long n, q, l, r;
    cin>>n;
    for(int i=1; i<=n; i++) cin>>a[i];
    for(int i=2; i<=n; i++) {
        p[i]=p[i-1];
        pr[i]=pr[i-1];
        if(a[i]<a[i-1]) {
            p[i]++;
            pr[i]=i;
        }
    }
    cin>>q;
    while(q--) {
        cin>>l>>r;
        if(p[r]-p[l]>1) {
            cout<<"NE\n";
        }
        else if(p[r]==p[l]) {
            cout<<"DA\n";
        }
        else {
            if(pr[r]==r||a[pr[r]-1]<=a[pr[r]+1]||a[pr[r]-2]<=a[pr[r]]) {
                cout<<"DA\n";
            }
            else {
                cout<<"NE\n";
            }
        }
    }
    return 0;
}